// Lista liniowa - przykład rekurencji

#include <stdio.h>
#include <stdlib.h>

// Element listy: zawiera liczbę całkowitą x i wskazanie na następny element nast
struct elem {
	int x;
	struct elem * nast;
};

// Wstawianie na początek listy
struct elem * wstaw( struct elem * lista, int nowy ) {
	struct elem * nowy_elem = malloc( sizeof * nowy_elem );
	nowy_elem->x = nowy;
	nowy_elem->nast = lista;
	return nowy_elem;
}

// Rekurencyjne wstawianie na koniec listy
struct elem * dodaj( struct elem * lista, int nowy ) {
	if( lista == NULL ) {
  	struct elem * nowy_elem = malloc( sizeof * nowy_elem );
  	nowy_elem->x = nowy;
  	nowy_elem->nast = lista;
  	return nowy_elem;
	} else {
		lista->nast = dodaj( lista->nast, nowy );
		return lista;
	}
}

// Rekurencyjne wstawianie zachowujące posortowanie listy
struct elem * sortuj( struct elem * lista, int nowy ) {
	if( lista == NULL || lista->x > nowy ) {
  	struct elem * nowy_elem = malloc( sizeof * nowy_elem );
  	nowy_elem->x = nowy;
  	nowy_elem->nast = lista;
  	return nowy_elem;
	} else {
		lista->nast = sortuj( lista->nast, nowy ); // TUTAJ BYŁ BŁĄD (było dodaj zamiast sortuj)
		return lista;
	}
}

// Wypisywanie listy - iteracyjne
void iteruj_wypisz( struct elem * lista ) {
	while( lista != NULL ) {
		printf( "%d -> ", lista->x );
		lista = lista->nast;
	}
}

// Wypisywanie listy - rekurencyjne proste
void wypisz( struct elem * lista ) {
	if( lista != NULL ) {
		printf( "%d -> ", lista->x );
    wypisz( lista->nast );
	}
}

// Wypisywanie listy - rekurencyjne wspak
void wspak( struct elem * lista ) {
	if( lista != NULL ) {
		printf( "%d -> ", lista->x );
    wypisz( lista->nast );
	}
}

int main() {
	struct elem * lista_a = NULL; // na tej elementy będą w kolejności dodawania
	struct elem * lista_b = NULL; // na tej odwrotnie
	struct elem * lista_c = NULL; // na tej posortowane
	int n = 10;

	for( int i= 0; i < n; i++ ) {
		int j = rand() % 100;
		lista_a = dodaj( lista_a, j );
		lista_b = wstaw( lista_b, j );
		lista_c = sortuj( lista_c, j );
	}

	printf( "\nTak liczby byly generowane: " );
	wypisz( lista_a );
	printf( "KONIEC\n\n" );

	printf( "Tu sa w odwrotnej kolejnosci: " );
	wypisz( lista_b );
	printf( "KONIEC\n\n" );

	printf( "A tutaj posortowane: " );
	wypisz( lista_c );
	printf( "KONIEC\n\n" );

	return 0;
}
